local agent_helper = require("scripts/agent/agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.cq02.youyannet.com/abm/login_verify.php",
	uid = "",
	pay_url = "http://cls.cq02.youyannet.com/abm/pay.php",
}

--退出--按返回键，首先是来到这里的--muyiqq5242095  
function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result)--调java
		if "true" == result then
			Log("退出游戏")
			AdapterToLua:endGame()
		else
			local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }
			self:OpenAlertDialog(format, function (result) if "positive" == result then 
				AdapterToLua:endGame()
			end end)
		end
	end)
end
-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid().."_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "abm"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "abm_".. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return "比奇世界"
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:LoginCallback(result)  
	local json_obj = cjson.decode(result)

	local openId = json_obj.openId			
	local token = json_obj.token		

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	local real_url = string.format("%s?spid=%s&device=%s&openId=%s&token=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()), openId, token)
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end
function AgentAdapter:OnClickBackLogin()
	PlatformBinder:JsonCall("call_agent_logout")
end

function AgentAdapter:OnClickRestartGame()
	PlatformBinder:JsonCall("call_agent_logout")
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()--跳到登录界面
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	local user_vo = GameVoManager.Instance:GetUserVo()
	
	local CpOrderId = server_id .. "_" .. self.uid .. "_" .. os.time() .. "_" .. role_id
	local param_obj = {}
	param_obj.orderId = CpOrderId
	param_obj.goodsDesc = amount*10 .. "元宝"
	param_obj.goodsName = amount*10 .. "元宝"
	param_obj.payAmount = tostring(amount)
	param_obj.payUrl = self.pay_url
	
	Log("AgentAdapter:Pay======" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self:SubmitInfo(0)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(1)
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(2)
end

function AgentAdapter:SubmitInfo(type)
		local role_vo = GameVoManager.Instance:GetMainRoleVo()
		local user_vo = GameVoManager.Instance:GetUserVo()

		if role_vo ~= nil and user_vo ~= nil then
			local info = {}
			info.server_id = tostring(user_vo.plat_server_id)
			info.server_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
			info.role_name = role_vo.name
			info.role_id = tostring(user_vo.cur_role_id)
			info.user_level = tostring(role_vo[OBJ_ATTR.CREATURE_LEVEL]) or "0"

			info.sub_type = tostring(type)

			print(cjson.encode(info))
			PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
		end
end


--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
