----------------------------------------------------
-- LoginServerItem
----------------------------------------------------
LoginServerItem = LoginServerItem or BaseClass(BaseRender)
function LoginServerItem:__init(w, h)
	self.width, self.height = 309, 85
	self.view:setContentWH(self.width, self.height + 10)
end

function LoginServerItem:__delete()
	
end

function LoginServerItem:CreateChild()
	BaseRender.CreateChild(self)

	local btn_select_path = ResPath.GetLogin("btn_server_select")
	self.select_eff = XUI.CreateToggleButton(self.width / 2, self.height / 2, 309, 67, true, ResPath.GetLogin("btn_server_normal"), btn_select_path, "", true)
	XUI.AddClickEventListener(self.select_eff,BindTool.Bind(self.OnClickBtn,self))
	self.view:addChild(self.select_eff)

	self.point = XUI.CreateImageView(30, self.height / 2-10, ResPath.GetLogin("point_1"))--muyiqq5242095  
	self.select_eff:addChild(self.point, 10)

	self.text_server_name = XUI.CreateText(50, self.height / 2-10, 0, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 25, COLOR3B.G_W)
	self.text_server_name:setAnchorPoint(0, 0.5)
	self.select_eff:addChild(self.text_server_name)

	self.text_server_time = XUI.CreateText(150, -15, 0, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 25, COLOR3B.G_W)
	self.select_eff:addChild(self.text_server_time)

	self:OnSelectChange(self:IsSelect())
end

function LoginServerItem:OnClickBtn()
	self:OnClick()
end	

function LoginServerItem:OnFlush()
	if self.data == nil then return end
	local open_tips = ""
	local now_server_time = GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time)
	-- 开服时间
	if nil ~= self.data.open_time and now_server_time < self.data.open_time then
		local t_time = os.date("*t", self.data.open_time)
		open_tips = string.format(Language.Login.ServerOpenTips, t_time.month, t_time.day, t_time.hour, t_time.min)
	-- 维护时间
	elseif nil ~= self.data.pause_time and now_server_time < self.data.pause_time then
		local t_time = os.date("*t", self.data.pause_time)
		open_tips = string.format(Language.Login.ServerOpenTips, t_time.month, t_time.day, t_time.hour, t_time.min)
	end

	local server_text = ""
	local show_server_id = self.data.id 
	local show_1500 = 1500
	local show_2000 = 2000

	local server_offset = GLOBAL_CONFIG.server_info.server_offset or 0
	if server_offset >= 1500 then
		server_offset = 0
	end
	if show_server_id < show_1500 and show_server_id > server_offset then 	--偏移id
		show_server_id = show_server_id - server_offset
	end

	if show_server_id > show_1500 and show_server_id < show_2000 then
		show_server_id = show_server_id - show_1500
	end
	if show_2000 == show_server_id then
		server_text = self.data.name 
	else
		if self.data.show_name_pre then
			if self.data.show_name_pre == "" then
				server_text = self.data.name
			else	
				server_text = self.data.show_name_pre .. Language.Login.Fu .. "-" .. self.data.name
			end	 	
		else	
			server_text = show_server_id .. Language.Login.Fu .. "-" .. self.data.name 
		end		
	end
	self.text_server_name:setString(server_text)
	-- local flag = self.data.flag
	self.point:loadTexture(ResPath.GetLogin("point_"..self.data.flag))
	local txt = self.data.open_time > now_server_time and "(" .. os.date("%Y/%m/%d %H:%M", self.data.open_time) .. ")" or ""
	--self.text_server_time:setString(txt)
end

function LoginServerItem:CreateSelectEffect()
end

-- 选择状态改变
function LoginServerItem:OnSelectChange(is_select)
	if nil == self.select_eff then return end
	self.select_eff:setTogglePressed(is_select)
end

----------------------------------------------------
-- LoginSelectServersItem
----------------------------------------------------
LoginSelectServersItem = LoginSelectServersItem or BaseClass(BaseRender)
function LoginSelectServersItem:__init(w, h)
	self.width, self.height = w, 90
	self.view:setContentWH(self.width, self.height)
end

function LoginSelectServersItem:__delete()
	
end

function LoginSelectServersItem:CreateChild()
	BaseRender.CreateChild(self)

	self.img_bg = XUI.CreateImageView(self.width / 2, self.height / 2, "", true)
	self.view:addChild(self.img_bg)

	self.text_desc = XUI.CreateText(self.width / 2, self.height / 2, 170, 28, nil, "", nil, 28, COLOR3B.GOLD)
	self.view:addChild(self.text_desc)

	self:OnSelectChange(self:IsSelect())
end

function LoginSelectServersItem:OnFlush()
	if #self.data <= 0 then
		self.text_desc:setString(Language.Login.TuiJian)
	elseif self.data[1].id >= 2000 then
		self.text_desc:setString(Language.Common.TestServer)
	else
		self.text_desc:setString(self:GetTxtStr())
	end
end

function LoginSelectServersItem:GetTxtStr()
	local str = self.index
	if self.data == nil then return str end

	local min_id = self.data[#self.data].id
	local max_id = self.data[1].id

	local client_sort_cfg = ClientServerListSortCfgFun.GetSortListCfg(AgentAdapter:GetSpid())
	if client_sort_cfg then
		for i,v in ipairs(client_sort_cfg) do
			if max_id <= v[1] then
				return v[2]
			end	
		end	
	end

	local server_offset = GLOBAL_CONFIG.server_info.server_offset or 0
	local show_1500 = 1500
	local show_2000 = 2000
	if server_offset >= show_1500 then
		server_offset = 0
	end

	if min_id < show_1500 and min_id > server_offset then
		min_id = min_id - server_offset
	end

	if min_id > show_1500 and min_id < show_2000 then
		min_id = min_id - show_1500
	end

	if max_id < show_1500 and max_id > server_offset then
		max_id = max_id - server_offset
	end

	if max_id > show_1500 and max_id < show_2000 then
		max_id = max_id - show_1500
	end

	if min_id == max_id then
		str = min_id .. Language.Login.Fu
	else
		str = min_id .. "-" .. max_id .. Language.Login.Fu
	end
	return str
end

function LoginSelectServersItem:CreateSelectEffect()
end

-- 选择状态改变
function LoginSelectServersItem:OnSelectChange(is_select)
	if nil == self.img_bg then return end
	if is_select then
		self.img_bg:loadTexture(ResPath.GetCommon("btn_106_select"))
	else 
		self.img_bg:loadTexture(ResPath.GetCommon("btn_106_normal"))
	end
end
